from stable_baselines3 import A2C
from stable_baselines3.common.env_util import make_vec_env
from huggingface_hub import login
from huggingface_sb3 import push_to_hub
import wandb




def play(model):
    obs = vec_env.reset()
    while True:
        action, _states = model.predict(obs)
        obs, rewards, dones, info = vec_env.step(action)
        vec_env.render("human")

if __name__ == "__main__":
    # start a new wandb run to track this script
    config = {
        "policy_type": "MlpPolicy",
        "total_timesteps": 25000,
        "env_name": "CartPole-v1",
    }
    wandb.login(key='xxxxxxx')
    run = wandb.init(
        project="cartpole",
        config=config,
        sync_tensorboard=True,
        monitor_gym=True,
        save_code=True,
    )
    # Parallel environments
    vec_env = make_vec_env("CartPole-v1", n_envs=4)

    model = A2C("MlpPolicy", vec_env, verbose=1)
    model.learn(total_timesteps=25000)
    model.save("a2c_cartpole")

    if False :
        login(token="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")
        push_to_hub(
            repo_id="Thomstr/A2C_CartPole",
            filename="a2c_cartpole.zip",
            commit_message="Added A2C model for CartPole with Stable Baselines3",
        )




